## initramfs-tools 0.146ubuntu2

=== debian/changelog ===
initramfs-tools (0.146ubuntu2) plucky; urgency=medium

  * mkinitramfs: add --version parameter
  * update-initramfs: add --version parameter
  * kernel/postinst.d: check for correct update-initramfs provider

 -- Benjamin Drung <bdrung@ubuntu.com>  Sat, 22 Mar 2025 00:16:14 +0100

initramfs-tools (0.146ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Harmonize kernel module installation with dracut's behavior:
      - hook-functions: Move UFS storage drivers to block class
      - Use the symbol regex from dracut-install to reduce the unnessary block
        kernel modules.
      - Do not install ARM/RISCV specific modules on other architectures.
    - add squashfs to list of 'most' modules
    - test:
      - let run_qemu* take extra kernel parameters as single parameter
      - Move network parameters to run_qemu
      - support setting a disk label in build_fs_ext2
      - test-common: move disc logic out of _run_qemu
      - Add qemu-net-iscsi autopkgtest
    - Revert "autopkgtest: Fix test failure when built-in drivers request
      firmware". This workaround is not needed on Ubuntu.
    - support mounting of loopback devices via loop*= parameters
    - Add vfat and nls modules to the initramfs.
    - Drop hooks/keymap, scripts/init-top/keymap, and associated code;
      console-setup takes care of this in Ubuntu.
    - Allow scripts and hooks to specify OPTION=VAR, and unless VAR is set to
      something other than "n", the script will not be included.
    - Add new initramfs-tools-bin package containing a binary that uses
      libudev to wait for udev to create the udev device, or wait for udev to
      finish processing if we catch it in the act, and returns the filesystem
      type as already probed by udev.
    - Automatically blacklist vga16fb when vga= or video= specified on kernel
      command-line.
    - Add hwaddr= alias for BOOTIF= for compatibility.
    - Set hostname at boot, for the benefit of mdadm autoassembly.
    - Add Hyper-V paravirtualised device drivers to the initramfs to allow
      booting of stock images in a Hyper-V guest.
    - ppc64el: enable PowerPC NX Crypto Coprocessor
    - Add support for uppercase and lowercase uuids.
    - Ensure we have a /usr/sbin directory in initramfs-tools-core
    - Make busybox-initramfs a real runtime dependency, fixing kernel install
      failures with cryptsetup
    - init: Don't interpret "rootdelay" as a static sleep.
    - scripts/local: Let rootdelay determine the wait-for-root timeout.
    - Increase rootdelay to 180s on powerpc/ppc64/ppc64el
    - Support roottimeout= as the authoritative name for rootdelay= since the
      Ubuntu interpretation of rootdelay is *not* a delay and this causes
      inconsistent behavior depending on whether the kernel or an initramfs is
      interpreting it.
    - Revised mountroot failure support.  This is now deprecated and
      effectively removed.  However, to prevent breakage in other packages the
      add_mountroot_fail_hook function is still present as an empty stub.
    - Add a new 'fixrtc' script that tries to set the system clock forward
      based on the last mount time of the root disk; without this kludge,
      systems without a working RTC will end up in a perpetual reboot loop.
    - Restore the framebuffer hook and script, copying KMS and other
      framebuffer drivers into the initramfs, but make them optional; you need
      to set FRAMEBUFFER=y for these to be included.
    - netinfo_to_resolv_conf: Add support for IPv6
    - resume: only resume when the partition contains a resume image
    - Fix resuming a hibernate session from a swapfile
    - scripts/functions: by default, when setting up networking, use dhclient
      if we're asked to do DHCP explicitly, or if we otherwise are expected to
      do things automatically.
    - split out IPv6 options in its own cmdline parameter: ip6= ; always use
      dhclient in this case if the value set is anything other than 'off' or
      'none'. Furthermore, parse anything other than 'on', 'dhcp' or 'any' as
      the name of an interface.
    - rework the stop conditions so that we properly handle the ROUNDTTT loop,
      timing out after a short period of time and trying again after a short
      sleep.
    - add a 'done' parameter for both ip= and ip6= so that we can properly
      exit the ROUNDTTT loop once we know that either there is no work to do,
      or that we've achieved what we wanted (that is, to bring up IPv4, IPv6,
      or possibly both).
    - Just let dhclient scan the interfaces if none is specified for IPv6.
      (previously unnoted)
    - Do not handle ip=rarp specially (ipconfig hasn't supported it for some
      time)
    - Call dhclient in simple cases for IPv4 (this makes some small observable
      changes -- for example ip=bootp will now make a DHCP request too -- but
      nothing that seems important).
    - Do not let dhclient processes hang around past the pivot and have them
      respect the shorter timeouts ipconfig was given.
    - hook-functions, mkinitramfs, scripts/functions: support usage of dns
      after configure_networking.
    - Add unit tests for DNS support
    - scripts/functions: write netplan config files to /run/netplan for
      network devices configured with configure_networking.
    - Adjust testsuite for correct expected netplan output.
    - Add tests to parse netplan.yaml with netplan generate.
    - scripts/functions: include a new option to skip enslaved network
      devices.
    - Auto activate qeth devices on s390x hosts, when using ip= ip6= command
      lines.
    - Add support for creating VLANs via vlan=eth0.1:eth0 on kernel
      commandline, and as VLAN= conf.d snippet.
    - Emit empty dictionary in the ethernets section, for static vlan configs
      without any matches, as otherwise it is invalid config.
    - Skip attempting to chzdev enable VLAN device


=== debian/control ===
Source: initramfs-tools
Section: utils
Priority: optional
Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13),
               libudev-dev,
               netplan.io [!i386] <!nocheck>,
               pkgconf,
               shellcheck [!i386] <!nocheck>,
               shunit2 <!nocheck>,
               udev [!i386] <!nocheck>
Rules-Requires-Root: no
Standards-Version: 4.7.0
Vcs-Browser: https://code.launchpad.net/~ubuntu-core-dev/ubuntu/+source/initramfs-tools/+git/initramfs-tools
Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/initramfs-tools
X-Debian-Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
X-Debian-Vcs-Git: https://salsa.debian.org/kernel-team/initramfs-tools.git

Package: initramfs-tools
Architecture: all
Multi-Arch: foreign
Depends: initramfs-tools-core (= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: bash-completion
Provides: linux-initramfs-tool
Conflicts: linux-initramfs-tool
Description: generic modular initramfs generator (automation)
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: initramfs-tools-core
Architecture: all
Multi-Arch: foreign
Recommends: zstd
Depends: coreutils (>= 8.24),
         cpio (>= 2.12),
         dhcpcd-base,
         dracut-install,
         e2fsprogs,
         initramfs-tools-bin (= ${binary:Version}),
         klibc-utils (>= 2.0.4-8~),
         kmod,
         logsave | e2fsprogs (<< 1.45.3-1~),
         udev,
         ${busybox:Depends},
         ${misc:Depends}
Suggests: 3cpio, bash-completion
Breaks: miniramfs (<< 1.0.2ubuntu1~)
Description: generic modular initramfs generator (core tools)
 This package contains the mkinitramfs program that can be used to
 create a bootable initramfs for a Linux kernel.  The initramfs should
 be loaded along with the kernel and is then responsible for mounting
 the root filesystem and starting the main init system.

Package: initramfs-tools-bin
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: binaries used by initramfs-tools
 This package contains binaries used inside the initramfs images generated
 by initramfs-tools.

=== debian/tests/control ===
Test-Command: ./tests/run-tests
Depends: netplan.io, udev
Restrictions: allow-stderr
Features: test-name=unit-tests

Tests: qemu-klibc
Architecture: amd64 armhf s390x
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

Tests: qemu-busybox
Architecture: amd64 armhf s390x
Restrictions: needs-root
Depends: busybox | busybox-initramfs,
         e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

Tests: qemu-ata-only
Architecture: amd64
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         klibc-utils,
         linux-image-generic,
         qemu-kvm,
         zstd,
         @

Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root
Depends: e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net-dnsmasq
Architecture: amd64 armhf s390x
Restrictions: needs-root
Depends: e2fsprogs,
         dnsmasq,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         procps,
         python3,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

# qemu-net-iscsi fails on arm64: https://launchpad.net/bugs/2097568
Tests: qemu-net-iscsi
Architecture: amd64 armhf ppc64el s390x
Restrictions: needs-root
Depends: busybox | busybox-initramfs,
         dnsmasq,
         e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         open-iscsi,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         tgt,
         zstd,
         @

Tests: copy-file
Restrictions: needs-root, skip-not-installable, superficial, allow-stderr
Depends: linux-image-generic, zstd, @

## initramfs-tools 0.147

=== debian/changelog ===
initramfs-tools (0.147) unstable; urgency=medium

  [ Ben Hutchings ]
  * [34f9acd] hook-functions: Add reset drivers when MODULES=dep (Closes:
    #1027458)
  * [025ce79] unmkinitramfs: Create temporary directory for initramfs
    parts
  * [25b0c61] unmkinitramfs: Fix detection of EOF marker
  * [ca1a68b] unmkinitramfs: Restore split to "early" and "main"
    subdirectories (Closes: #1100008)
  * [bbbe1d3] unmkinitramfs.8: Update and expand description of multi-
    archive handling

  [ Chris Hofstaedtler ]
  * [297a9e2] hook-functions: avoid aborting in chroots
  * [319cdc9] Tighten /dev/pts permissions (Closes: #1095991)

  [ Scott Moser ]
  * [cec12d7] hook-functions: add squashfs driver (LP: #1501834)

  [ Benjamin Drung ]
  * [a6884dc] test: let run_qemu* take extra kernel parameters as single
    parameter
  * [5401bf3] test: support setting a disk label in build_fs_ext2
  * [ab1fe4e] test-common: introduce intermediate
    _run_qemu_default_devices
  * [20c564a] Add qemu-net-iscsi autopkgtest (LP: #2091904)
  * [716491a] mkinitramfs: add --version parameter
  * [65166a6] update-initramfs: add --version parameter
  * [2334de3] kernel/postinst.d: check for correct update-initramfs
    provider
  * [7ef4755] Fix spelling mistakes in d/changelog
  * [3ed4077] hook-functions: Move UFS storage drivers to block class (LP:
    #2081020)
  * [19b85a5] Filter block kernel modules by symbol regex from dracut (LP:
    #2031841)
  * [4069428] update-initramfs: add -s parameter (LP: #1466965)
  * [7f2ed35] Avoid updating the initramfs twice for some cases (LP:
    #1466965)
  * [dad2c90] test: run quick copy-file autopkgtest first
  * [32aa743] Bump Standards-Version to 4.7.2

 -- Ben Hutchings <benh@debian.org>  Fri, 28 Mar 2025 02:07:15 +0100

=== debian/control ===
Source: initramfs-tools
Section: utils
Priority: optional
Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
Build-Depends: bash-completion, debhelper-compat (= 13), shunit2 <!nocheck>
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
Vcs-Git: https://salsa.debian.org/kernel-team/initramfs-tools.git

Package: initramfs-tools
Architecture: all
Multi-Arch: foreign
Depends: initramfs-tools-core (= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: bash-completion
Provides: linux-initramfs-tool
Conflicts: linux-initramfs-tool
Description: generic modular initramfs generator (automation)
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: initramfs-tools-core
Architecture: all
Multi-Arch: foreign
Recommends: zstd, ${busybox:Recommends}
Depends: coreutils (>= 8.24),
         cpio (>= 2.12),
         dracut-install,
         klibc-utils (>= 2.0.4-8~),
         kmod,
         logsave | e2fsprogs (<< 1.45.3-1~),
         udev,
         ${misc:Depends}
Suggests: bash-completion
Breaks: miniramfs (<< 1.0.3~)
Description: generic modular initramfs generator (core tools)
 This package contains the mkinitramfs program that can be used to
 create a bootable initramfs for a Linux kernel.  The initramfs should
 be loaded along with the kernel and is then responsible for mounting
 the root filesystem and starting the main init system.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --with bash-completion

# On Debian we can use either busybox or busybox-static, but on Ubuntu
# and derivatives only busybox-initramfs will work.
BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)

override_dh_gencontrol:
	echo >> debian/initramfs-tools-core.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
	dh_gencontrol

override_dh_install:
	sed -e 's,@BUSYBOX_PACKAGES@,$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=or %)),;s,@VERSION@,$(DEB_VERSION),' \
		mkinitramfs > debian/initramfs-tools-core/usr/sbin/mkinitramfs
	chmod 755 debian/initramfs-tools-core/usr/sbin/mkinitramfs
	dh_install

override_dh_installinitramfs:
	@:

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	tests/functions_test
endif

=== debian/tests/control ===
Tests: copy-file
Restrictions: needs-root, breaks-testbed, skip-not-installable, superficial, allow-stderr
Depends: linux-image-generic, zstd, @

Tests: qemu-klibc
Architecture: amd64 armhf s390x
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

Tests: qemu-busybox
Architecture: amd64 armhf s390x
Restrictions: needs-root, breaks-testbed
Depends: busybox | busybox-initramfs,
         e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-arm [armhf],
         qemu-kvm,
         zstd,
         @

Tests: qemu-ata-only
Architecture: amd64
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         klibc-utils,
         linux-image-generic,
         qemu-kvm,
         zstd,
         @

Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: needs-root, breaks-testbed
Depends: e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         zstd,
         @

Tests: qemu-net-iscsi
Architecture: amd64 arm64 armhf ppc64el s390x
Restrictions: breaks-testbed, needs-root
Depends: busybox | busybox-initramfs,
         dnsmasq,
         e2fsprogs,
         genext2fs,
         iproute2,
         ipxe-qemu,
         klibc-utils,
         linux-image-generic,
         open-iscsi,
         procps,
         python3,
         qemu-efi-aarch64 [arm64],
         qemu-efi-arm [armhf],
         qemu-kvm,
         seabios [ppc64el],
         tgt,
         zstd,
         @

## initramfs-tools 0.147ubuntu1

=== debian/changelog ===
initramfs-tools (0.147ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Harmonize kernel module installation with dracut's behavior:
      - Do not install ARM/RISCV specific modules on other architectures.
    - Revert "autopkgtest: Fix test failure when built-in drivers request
      firmware". This workaround is not needed on Ubuntu.
    - support mounting of loopback devices via loop*= parameters
    - Add vfat and nls modules to the initramfs.
    - Drop hooks/keymap, scripts/init-top/keymap, and associated code;
      console-setup takes care of this in Ubuntu.
    - Allow scripts and hooks to specify OPTION=VAR, and unless VAR is set to
      something other than "n", the script will not be included.
    - Add new initramfs-tools-bin package containing a binary that uses
      libudev to wait for udev to create the udev device, or wait for udev to
      finish processing if we catch it in the act, and returns the filesystem
      type as already probed by udev.
    - Automatically blacklist vga16fb when vga= or video= specified on kernel
      command-line.
    - Add hwaddr= alias for BOOTIF= for compatibility.
    - Set hostname at boot, for the benefit of mdadm autoassembly.
    - Add Hyper-V paravirtualised device drivers to the initramfs to allow
      booting of stock images in a Hyper-V guest.
    - ppc64el: enable PowerPC NX Crypto Coprocessor
    - Add support for uppercase and lowercase uuids.
    - Ensure we have a /usr/sbin directory in initramfs-tools-core
    - Make busybox-initramfs a real runtime dependency, fixing kernel install
      failures with cryptsetup
    - init: Don't interpret "rootdelay" as a static sleep.
    - scripts/local: Let rootdelay determine the wait-for-root timeout.
    - Increase rootdelay to 180s on powerpc/ppc64/ppc64el
    - Support roottimeout= as the authoritative name for rootdelay= since the
      Ubuntu interpretation of rootdelay is *not* a delay and this causes
      inconsistent behavior depending on whether the kernel or an initramfs is
      interpreting it.
    - Revised mountroot failure support.  This is now deprecated and
      effectively removed.  However, to prevent breakage in other packages the
      add_mountroot_fail_hook function is still present as an empty stub.
    - Add a new 'fixrtc' script that tries to set the system clock forward
      based on the last mount time of the root disk; without this kludge,
      systems without a working RTC will end up in a perpetual reboot loop.
    - Restore the framebuffer hook and script, copying KMS and other
      framebuffer drivers into the initramfs, but make them optional; you need
      to set FRAMEBUFFER=y for these to be included.
    - netinfo_to_resolv_conf: Add support for IPv6
    - resume: only resume when the partition contains a resume image
    - Fix resuming a hibernate session from a swapfile
    - scripts/functions: by default, when setting up networking, use dhclient
      if we're asked to do DHCP explicitly, or if we otherwise are expected to
      do things automatically.
    - split out IPv6 options in its own cmdline parameter: ip6= ; always use
      dhclient in this case if the value set is anything other than 'off' or
      'none'. Furthermore, parse anything other than 'on', 'dhcp' or 'any' as
      the name of an interface.
    - rework the stop conditions so that we properly handle the ROUNDTTT loop,
      timing out after a short period of time and trying again after a short
      sleep.
    - add a 'done' parameter for both ip= and ip6= so that we can properly
      exit the ROUNDTTT loop once we know that either there is no work to do,
      or that we've achieved what we wanted (that is, to bring up IPv4, IPv6,
      or possibly both).
    - Just let dhclient scan the interfaces if none is specified for IPv6.
      (previously unnoted)
    - Do not handle ip=rarp specially (ipconfig hasn't supported it for some
      time)
    - Call dhclient in simple cases for IPv4 (this makes some small observable
      changes -- for example ip=bootp will now make a DHCP request too -- but
      nothing that seems important).
    - Do not let dhclient processes hang around past the pivot and have them
      respect the shorter timeouts ipconfig was given.
    - hook-functions, mkinitramfs, scripts/functions: support usage of dns
      after configure_networking.
    - Add unit tests for DNS support
    - scripts/functions: write netplan config files to /run/netplan for
      network devices configured with configure_networking.
    - Adjust testsuite for correct expected netplan output.
    - Add tests to parse netplan.yaml with netplan generate.
    - scripts/functions: include a new option to skip enslaved network
      devices.
    - Auto activate qeth devices on s390x hosts, when using ip= ip6= command
      lines.
    - Add support for creating VLANs via vlan=eth0.1:eth0 on kernel
      commandline, and as VLAN= conf.d snippet.
    - Emit empty dictionary in the ethernets section, for static vlan configs
      without any matches, as otherwise it is invalid config.
    - Skip attempting to chzdev enable VLAN device
    - Work out the kernel modules required to support ZFS filesystems and add
      them as necessary.
    - Add modules for nvme path components on multipath nvme.
    - Drop usage of klibc-utils' fstype in favor of always using udev blkid.
    - Use set -a/+a around loading conf snippets, to autoexport hook
      configuration variables. This thus allows packaged hooks to configure
      each other.
    - Fix PATH to include /usr/local.
    - Fix resume failure due to resume=UUID=... in certain cases
    - Always mount loop-mount filesystems read-write; ntfs-3g and vfat can't
      remount yet.
    - Provide a clearer error on mount failure of the Windows host filesystem
    - scripts/local: Re-execute cryptroot local-block script.


=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,11 @@
 BUSYBOX_PACKAGES := $(shell if dpkg-vendor --derives-from ubuntu; then echo busybox-initramfs; else echo busybox busybox-static; fi)
 
 override_dh_gencontrol:
-	echo >> debian/initramfs-tools-core.substvars "busybox:Recommends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
+	echo >> debian/initramfs-tools-core.substvars "busybox:Depends=$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=| %))"
 	dh_gencontrol
 
 override_dh_install:
+	install -d debian/initramfs-tools-core/usr/sbin
 	sed -e 's,@BUSYBOX_PACKAGES@,$(wordlist 2,100,$(BUSYBOX_PACKAGES:%=or %)),;s,@VERSION@,$(DEB_VERSION),' \
 		mkinitramfs > debian/initramfs-tools-core/usr/sbin/mkinitramfs
 	chmod 755 debian/initramfs-tools-core/usr/sbin/mkinitramfs
@@ -22,7 +23,27 @@
 override_dh_installinitramfs:
 	@:
 
+DEB_BUILD_GNU_TYPE := $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+DEB_HOST_GNU_TYPE  := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
+CROSS :=
+else
+CROSS := CC=$(DEB_HOST_GNU_TYPE)-gcc PKG_CONFIG=$(DEB_HOST_GNU_TYPE)-pkg-config
+endif
+
+override_dh_auto_build:
+	make -C src $(CROSS)
+
+override_dh_auto_clean:
+	make -C src clean
+
+DEB_HOST_ARCH     := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+    ifeq (,$(filter i386,$(DEB_HOST_ARCH)))
+	shellcheck hook-functions $$(find hooks scripts -type f) $$({ find . -maxdepth 1 -type f -executable; find debian -maxdepth 1 -type f; find debian/tests docs kernel tests -type f; } | xargs grep -l '^#!/bin/sh')
+    endif
 	tests/functions_test
+	./tests/run-tests
 endif

=== debian/tests/control ===
--- 
+++ 
@@ -1,10 +1,15 @@
 Tests: copy-file
-Restrictions: needs-root, breaks-testbed, skip-not-installable, superficial, allow-stderr
+Restrictions: needs-root, skip-not-installable, superficial, allow-stderr
 Depends: linux-image-generic, zstd, @
+
+Test-Command: ./tests/run-tests
+Depends: netplan.io, udev
+Restrictions: allow-stderr
+Features: test-name=unit-tests
 
 Tests: qemu-klibc
 Architecture: amd64 armhf s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          ipxe-qemu,
@@ -17,7 +22,7 @@
 
 Tests: qemu-busybox
 Architecture: amd64 armhf s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: busybox | busybox-initramfs,
          e2fsprogs,
          genext2fs,
@@ -31,7 +36,7 @@
 
 Tests: qemu-ata-only
 Architecture: amd64
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          klibc-utils,
@@ -42,7 +47,7 @@
 
 Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
 Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          ipxe-qemu,
@@ -57,7 +62,7 @@
 
 Tests: qemu-net
 Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: needs-root, breaks-testbed
+Restrictions: needs-root
 Depends: e2fsprogs,
          genext2fs,
          iproute2,
@@ -73,9 +78,27 @@
          zstd,
          @
 
+Tests: qemu-net-dnsmasq
+Architecture: amd64 armhf s390x
+Restrictions: needs-root
+Depends: e2fsprogs,
+         dnsmasq,
+         genext2fs,
+         iproute2,
+         ipxe-qemu,
+         klibc-utils,
+         linux-image-generic,
+         procps,
+         python3,
+         qemu-efi-arm [armhf],
+         qemu-kvm,
+         zstd,
+         @
+
+# qemu-net-iscsi fails on arm64: https://launchpad.net/bugs/2097568
 Tests: qemu-net-iscsi
-Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: breaks-testbed, needs-root
+Architecture: amd64 armhf ppc64el s390x
+Restrictions: needs-root
 Depends: busybox | busybox-initramfs,
          dnsmasq,
          e2fsprogs,

## initramfs-tools 0.147ubuntu1.1

=== src/Makefile ===
PKG_CONFIG = pkg-config
UDEV_CFLAGS = $(shell $(PKG_CONFIG) --cflags libudev)
UDEV_LIBS = $(shell $(PKG_CONFIG) --libs libudev)

CC = gcc
CFLAGS = -g -Wall -O2 $(UDEV_CFLAGS)
LDFLAGS =


.PHONY: all
all: wait-for-root gcc_s1-stub

wait-for-root: wait-for-root.o
	$(CC) $(LDFLAGS) -o $@ $< $(UDEV_LIBS)

gcc_s1-stub:
	gcc -Wl,--no-as-needed -shared -l:libpthread.so.0 -l:libgcc_s.so.1 -o $@

.PHONY: clean
clean:
	rm -f wait-for-root.o wait-for-root gcc_s1-stub core *~

=== debian/changelog ===
initramfs-tools (0.147ubuntu1.1) plucky; urgency=medium

  * Fix missing panel modules in initramfs (LP: #2107477)
    - Fix include pattern for panel drivers if MODULES=dep
    - Include all bridge, panel and backlight drivers if MODULES=most

 -- Tobias Heider <tobias.heider@canonical.com>  Wed, 25 Jun 2025 14:50:25 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,16 @@
 Section: utils
 Priority: optional
 Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
-Build-Depends: bash-completion, debhelper-compat (= 13), shunit2 <!nocheck>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
+Build-Depends: bash-completion,
+               debhelper-compat (= 13),
+               libudev-dev,
+               netplan.io [!i386] <!nocheck>,
+               pkgconf,
+               shellcheck [!i386] <!nocheck>,
+               shunit2 <!nocheck>,
+               udev [!i386] <!nocheck>
 Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
@@ -26,19 +34,30 @@
 Package: initramfs-tools-core
 Architecture: all
 Multi-Arch: foreign
-Recommends: zstd, ${busybox:Recommends}
+Recommends: zstd
 Depends: coreutils (>= 8.24),
          cpio (>= 2.12),
+         dhcpcd-base,
          dracut-install,
+         e2fsprogs,
+         initramfs-tools-bin (= ${binary:Version}),
          klibc-utils (>= 2.0.4-8~),
          kmod,
          logsave | e2fsprogs (<< 1.45.3-1~),
          udev,
+         ${busybox:Depends},
          ${misc:Depends}
-Suggests: bash-completion
-Breaks: miniramfs (<< 1.0.3~)
+Suggests: 3cpio, bash-completion
+Breaks: miniramfs (<< 1.0.2ubuntu1~)
 Description: generic modular initramfs generator (core tools)
  This package contains the mkinitramfs program that can be used to
  create a bootable initramfs for a Linux kernel.  The initramfs should
  be loaded along with the kernel and is then responsible for mounting
  the root filesystem and starting the main init system.
+
+Package: initramfs-tools-bin
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: binaries used by initramfs-tools
+ This package contains binaries used inside the initramfs images generated
+ by initramfs-tools.

## initramfs-tools 0.148

=== debian/changelog ===
initramfs-tools (0.148) unstable; urgency=medium

  * [a797b42] unmkinitramfs: Rewrite in C to make it acceptably fast
  * [9e37d8b] Move unmkinitramfs to new initramfs-tools-bin package
  * [49f3bba] test: Add autopkgtest case for unmkinitramfs

 -- Ben Hutchings <benh@debian.org>  Wed, 28 May 2025 19:09:21 +0200

## initramfs-tools 0.148.1

=== debian/changelog ===
initramfs-tools (0.148.1) unstable; urgency=medium

  * No-change source upload to allow propagation to testing

 -- Ben Hutchings <benh@debian.org>  Wed, 28 May 2025 20:21:18 +0200

=== debian/control ===
Source: initramfs-tools
Section: utils
Priority: optional
Uploaders: Michael Prokop <mika@debian.org>, Ben Hutchings <benh@debian.org>
Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
Build-Depends: bash-completion, debhelper-compat (= 13), shunit2 <!nocheck>
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/kernel-team/initramfs-tools
Vcs-Git: https://salsa.debian.org/kernel-team/initramfs-tools.git

Package: initramfs-tools
Architecture: all
Multi-Arch: foreign
Depends: initramfs-tools-core (= ${binary:Version}),
         linux-base,
         ${misc:Depends}
Suggests: bash-completion
Provides: linux-initramfs-tool
Conflicts: linux-initramfs-tool
Description: generic modular initramfs generator (automation)
 This package builds a bootable initramfs for Linux kernel packages.  The
 initramfs is loaded along with the kernel and is responsible for
 mounting the root filesystem and starting the main init system.

Package: initramfs-tools-core
Architecture: all
Multi-Arch: foreign
Recommends: zstd, ${busybox:Recommends}
Depends: coreutils (>= 8.24),
         cpio (>= 2.12),
         dracut-install,
         initramfs-tools-bin (>= ${source:Version}),
         klibc-utils (>= 2.0.4-8~),
         kmod,
         logsave | e2fsprogs (<< 1.45.3-1~),
         udev,
         ${misc:Depends}
Suggests: bash-completion
Breaks: miniramfs (<< 1.0.3~)
Description: generic modular initramfs generator (core tools)
 This package contains the mkinitramfs program that can be used to
 create a bootable initramfs for a Linux kernel.  The initramfs should
 be loaded along with the kernel and is then responsible for mounting
 the root filesystem and starting the main init system.

Package: initramfs-tools-bin
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: initramfs-tools-core (<< 0.148~)
Description: generic modular initramfs generator (binary tools)
 This package contains the unmkinitramfs program that can be used to
 unpack an initramfs image.

## initramfs-tools 0.148.2

=== debian/changelog ===
initramfs-tools (0.148.2) unstable; urgency=medium

  [ Benjamin Drung ]
  * [3becdb7] Add missing Breaks to initramfs-tools-bin (for moved
    unmkinitramfs)

  [ Bastian Blank ]
  * [2246945] Re-add s390 specific scsi drivers (Closes: #1107689)

 -- Ben Hutchings <benh@debian.org>  Fri, 13 Jun 2025 00:55:37 +0200

## initramfs-tools 0.148.3

=== debian/changelog ===
initramfs-tools (0.148.3) unstable; urgency=medium

  [ Benjamin Drung ]
  * [e3f4fb4] Revert "Avoid updating the initramfs twice for some cases"
    (Closes: #1108204)

 -- Ben Hutchings <benh@debian.org>  Sun, 29 Jun 2025 14:08:36 +0200

=== debian/tests/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Tests: copy-file
-Restrictions: needs-root, skip-not-installable, superficial, allow-stderr
+Restrictions: needs-root, breaks-testbed, skip-not-installable, superficial, allow-stderr
 Depends: linux-image-generic, zstd, @
 
-Test-Command: ./tests/run-tests
-Depends: netplan.io, udev
-Restrictions: allow-stderr
-Features: test-name=unit-tests
+Tests: unmkinitramfs
+Restrictions: superficial
+Depends: bzip2, xz-utils, lzop, lz4, zstd, @
 
 Tests: qemu-klibc
 Architecture: amd64 armhf s390x
-Restrictions: needs-root
+Restrictions: needs-root, breaks-testbed
 Depends: e2fsprogs,
          genext2fs,
          ipxe-qemu,
@@ -22,7 +21,7 @@
 
 Tests: qemu-busybox
 Architecture: amd64 armhf s390x
-Restrictions: needs-root
+Restrictions: needs-root, breaks-testbed
 Depends: busybox | busybox-initramfs,
          e2fsprogs,
          genext2fs,
@@ -36,7 +35,7 @@
 
 Tests: qemu-ata-only
 Architecture: amd64
-Restrictions: needs-root
+Restrictions: needs-root, breaks-testbed
 Depends: e2fsprogs,
          genext2fs,
          klibc-utils,
@@ -47,7 +46,7 @@
 
 Tests: qemu-virtio-only qemu-separate-usr qemu-panic-shell
 Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: needs-root
+Restrictions: needs-root, breaks-testbed
 Depends: e2fsprogs,
          genext2fs,
          ipxe-qemu,
@@ -62,7 +61,7 @@
 
 Tests: qemu-net
 Architecture: amd64 arm64 armhf ppc64el s390x
-Restrictions: needs-root
+Restrictions: needs-root, breaks-testbed
 Depends: e2fsprogs,
          genext2fs,
          iproute2,
@@ -78,27 +77,9 @@
          zstd,
          @
 
-Tests: qemu-net-dnsmasq
-Architecture: amd64 armhf s390x
-Restrictions: needs-root
-Depends: e2fsprogs,
-         dnsmasq,
-         genext2fs,
-         iproute2,
-         ipxe-qemu,
-         klibc-utils,
-         linux-image-generic,
-         procps,
-         python3,
-         qemu-efi-arm [armhf],
-         qemu-kvm,
-         zstd,
-         @
-
-# qemu-net-iscsi fails on arm64: https://launchpad.net/bugs/2097568
 Tests: qemu-net-iscsi
-Architecture: amd64 armhf ppc64el s390x
-Restrictions: needs-root
+Architecture: amd64 arm64 armhf ppc64el s390x
+Restrictions: breaks-testbed, needs-root
 Depends: busybox | busybox-initramfs,
          dnsmasq,
          e2fsprogs,

## initramfs-tools 0.148.3+rpt2

=== debian/changelog ===
initramfs-tools (0.148.3+rpt2) trixie; urgency=medium

  * [83ec91e] Change default RUNSIZE to 20%

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 21 Jul 2025 08:37:35 +0100

initramfs-tools (0.148.3+rpt1) trixie; urgency=medium

  * [ce04ab0] d/gbp.conf: set debian branch
  * [f3f2242] Run zstd with --single-thread on devices with < 1GB RAM
  * [f59ea7c] If update_initramfs=yes, update initramfs for all flavours
    of the latest rpi kernel version

 -- Serge Schneider <serge@raspberrypi.com>  Mon, 07 Jul 2025 10:52:48 +0100

## initramfs-tools 0.149

=== debian/changelog ===
initramfs-tools (0.149) experimental; urgency=medium

  [ Alper Nebi Yasak ]
  * [d11ba24] Handle simple-framebuffer drivers built as modules
  * [72899f8] Handle framebuffer_coreboot driver built as a module

  [ Ben Hutchings ]
  * [8104218] unmkinitramfs: Stop splitting into "early" and "main"
    subdirectories
  * [02bd63a] unmkinitramfs: Add support for lzma compression

  [ Benjamin Drung ]
  * [ea29775] hook-functions: Print error message on copy_file failure
  * [8842365] Add missing Breaks to initramfs-tools-bin (for moved
    unmkinitramfs)

  [ Tobias Heider ]
  * [6fdd131] Fix include of panel drivers if MODULES=dep
  * [d82a1e9] Include all bridge, panel and backlight drivers if
    MODULES=most

  [ Bastian Blank ]
  * [39e24fe] Re-add s390 specific scsi drivers (Closes: #1107689)

 -- Ben Hutchings <benh@debian.org>  Fri, 13 Jun 2025 00:17:33 +0200
